%define anolis_release 2
%global nginx_user nginx
%global nginx_moduledir %{_libdir}/%{name}/modules
%global nginx_moduleconfdir %{_datadir}/%{name}/modules
%bcond_with qatzip

Name:		aa_nginx
Version:	1.22.1
Release:	%{anolis_release}%{?dist}
Summary:	Anolis accelerated NGINX*
License:	BSD
URL:		https://gitee.com/anolis/aa-nginx
Source0:	nginx-v1.22.1.tar.gz

BuildRequires:	openssl1.1-devel
BuildRequires:  qatzip-devel, libdlb-devel

BuildRequires:  pcre-devel
BuildRequires:  zlib-devel

Requires:	openssl1.1, pcre, libdlb, qatzip, qatzip-libs

ExclusiveArch: x86_64

%description
Nginx* [engine x] is an HTTP and reverse proxy server, a mail proxy server, 
and a generic TCP/UDP proxy server, originally written by Igor Sysoev. This
project provides an extended Nginx working with asynchronous mode OpenSSL*. 
With Intel® QuickAssist Technology (QAT) and Intel Dynamic Load Balancer (DLB)
acceleration, Anolis accelerated NGINX* can provide significant performance improvement.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
./configure \
	--prefix=%{_datadir}/%{name} \
	--sbin-path=%{_sbindir}/%{name} \
	--modules-path=%{nginx_moduledir} \
	--conf-path=%{_sysconfdir}/%{name}/%{name}.conf \
	--error-log-path=%{_localstatedir}/log/%{name}/error.log \
	--http-log-path=%{_localstatedir}/log/%{name}/access.log \
	--http-client-body-temp-path=%{_localstatedir}/lib/%{name}/tmp/client_body \
	--http-proxy-temp-path=%{_localstatedir}/lib/%{name}/tmp/proxy \
	--http-fastcgi-temp-path=%{_localstatedir}/lib/%{name}/tmp/fastcgi \
	--http-uwsgi-temp-path=%{_localstatedir}/lib/%{name}/tmp/uwsgi \
	--http-scgi-temp-path=%{_localstatedir}/lib/%{name}/tmp/scgi \
	--with-http_ssl_module \
	--add-dynamic-module=modules/nginx_qatzip_module \
	--add-dynamic-module=modules/nginx_qat_module/  \
	--pid-path=/run/%{name}.pid \
	--lock-path=/run/lock/subsys/%{name} \
	--with-cc-opt="-DNGX_SECURE_MEM -I$OPENSSL_LIB/include -I$ICP_ROOT/quickassist/include -I$ICP_ROOT/quickassist/include/dc -Wno-error=deprecated-declarations" \
	--with-ld-opt="-L$OPENSSL_LIB/lib64 -lqatzip -ldlb -lpcre" \
	--user=%{nginx_user} \
	--group=%{nginx_user} \
	--with-debug

%make_build

%install
%make_install
install -p -d -m 0700 %{buildroot}%{_localstatedir}/lib/%{name}
install -p -d -m 0700 %{buildroot}%{_localstatedir}/lib/%{name}/tmp
install -p -d -m 0700 %{buildroot}%{_localstatedir}/log/%{name}
mv %{buildroot}/%{_sysconfdir}/%{name}/nginx.conf.default %{buildroot}/%{_sysconfdir}/%{name}/%{name}.conf.default

install -p -d -m 0755 %{buildroot}%{_datadir}/%{name}/modules
install -p -d -m 0755 %{buildroot}%{_libdir}/%{name}/modules
echo 'load_module %{nginx_moduledir}/ngx_ssl_engine_qat_module.so;' \
	> %{buildroot}/%{nginx_moduleconfdir}/mod-ssl-engine-qat.conf
echo 'load_module %{nginx_moduledir}/ngx_http_qatzip_filter_module.so;' \
         > %{buildroot}/%{nginx_moduleconfdir}/mod-http-qatzip-filter.conf

%files
%license LICENSE
%dir %{_datadir}/%{name}
%dir %{_sysconfdir}/%{name}
%{_datadir}/%{name}/html/*
%{_sbindir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/fastcgi.conf
%config(noreplace) %{_sysconfdir}/%{name}/fastcgi.conf.default
%config(noreplace) %{_sysconfdir}/%{name}/fastcgi_params
%config(noreplace) %{_sysconfdir}/%{name}/fastcgi_params.default
%config(noreplace) %{_sysconfdir}/%{name}/koi-utf
%config(noreplace) %{_sysconfdir}/%{name}/koi-win
%config(noreplace) %{_sysconfdir}/%{name}/mime.types
%config(noreplace) %{_sysconfdir}/%{name}/mime.types.default
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf.default
%config(noreplace) %{_sysconfdir}/%{name}/scgi_params
%config(noreplace) %{_sysconfdir}/%{name}/scgi_params.default
%config(noreplace) %{_sysconfdir}/%{name}/uwsgi_params
%config(noreplace) %{_sysconfdir}/%{name}/uwsgi_params.default
%config(noreplace) %{_sysconfdir}/%{name}/win-utf
%dir %{nginx_moduledir}
%dir %{nginx_moduleconfdir}
%{nginx_moduledir}/ngx_http_qatzip_filter_module.so
%{nginx_moduleconfdir}/mod-http-qatzip-filter.conf
%{nginx_moduledir}/ngx_ssl_engine_qat_module.so
%{nginx_moduleconfdir}/mod-ssl-engine-qat.conf
%attr(770,%{nginx_user},root) %dir %{_localstatedir}/lib/%{name}
%attr(770,%{nginx_user},root) %dir %{_localstatedir}/lib/%{name}/tmp
%attr(711,root,root) %dir %{_localstatedir}/log/%{name}
%ghost %attr(640,%{nginx_user},root) %{_localstatedir}/log/%{name}/access.log
%ghost %attr(640,%{nginx_user},root) %{_localstatedir}/log/%{name}/error.log

%files doc
%doc README.md

%changelog
* Tue Sep 26 2023 Guanjun <guanjun@linux.alibaba.com> - 1.22.1-2
- add qatzip for aa_nginx

* Thu Sep 19 2023 Guanjun <guanjun@linux.alibaba.com> - 1.22.1-1
- init package
